/*
 * Generated by util/mkerr.pl DO NOT EDIT
 *
 *  engNTRU - An engine for batch NTRU PQC in OpenSSL.
 *  Copyright (C) 2019 Tampere University Foundation sr
 *
 *  This file is part of engNTRU.
 *
 *  engNTRU is free software: you can redistribute it and/or modify it under
 *  the terms of the GNU Lesser General Public License as published by the
 *  Free Software Foundation, either version 3 of the License, or (at your
 *  option) any later version.
 *
 *  engNTRU is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <openssl/err.h>
#include "ossl/engntru_err.h"

#ifndef OPENSSL_NO_ERR

static ERR_STRING_DATA ENGNTRU_str_functs[] = {
    {ERR_PACK(0, ENGNTRU_F_ASN1_GENERIC_CTRL, 0), "asn1_generic_ctrl"},
    {ERR_PACK(0, ENGNTRU_F_ASN1_GENERIC_PRIV_DECODE, 0),
     "asn1_generic_priv_decode"},
    {ERR_PACK(0, ENGNTRU_F_ASN1_GENERIC_PRIV_ENCODE, 0),
     "asn1_generic_priv_encode"},
    {ERR_PACK(0, ENGNTRU_F_ASN1_GENERIC_PUB_DECODE, 0),
     "asn1_generic_pub_decode"},
    {ERR_PACK(0, ENGNTRU_F_ASN1_GENERIC_PUB_ENCODE, 0),
     "asn1_generic_pub_encode"},
    {ERR_PACK(0, ENGNTRU_F_ENGNTRU_KEM_KEYPAIR_NEW, 0),
     "engntru_kem_keypair_new"},
    {ERR_PACK(0, ENGNTRU_F_GENERIC_KEM_DECRYPT, 0), "generic_kem_decrypt"},
    {ERR_PACK(0, ENGNTRU_F_GENERIC_KEM_DERIVE, 0), "generic_kem_derive"},
    {ERR_PACK(0, ENGNTRU_F_GENERIC_KEM_ENCRYPT, 0), "generic_kem_encrypt"},
    {ERR_PACK(0, ENGNTRU_F_GENERIC_KEM_KEYGEN, 0), "generic_kem_keygen"},
    {0, NULL}
};

static ERR_STRING_DATA ENGNTRU_str_reasons[] = {
    {ERR_PACK(0, 0, ENGNTRU_R_INVALID_DERIVE), "invalid derive"},
    {ERR_PACK(0, 0, ENGNTRU_R_INVALID_ENCODING), "invalid encoding"},
    {ERR_PACK(0, 0, ENGNTRU_R_INVALID_KEY), "invalid key"},
    {ERR_PACK(0, 0, ENGNTRU_R_INVALID_PEER_KEY), "invalid peer key"},
    {ERR_PACK(0, 0, ENGNTRU_R_INVALID_PRIVATE_KEY), "invalid private key"},
    {ERR_PACK(0, 0, ENGNTRU_R_KEYS_NOT_SET), "keys not set"},
    {ERR_PACK(0, 0, ENGNTRU_R_MISSING_NID_DATA), "missing nid data"},
    {ERR_PACK(0, 0, ENGNTRU_R_PROV_DECAPSULATE_FAILED),
    "prov decapsulate failed"},
    {ERR_PACK(0, 0, ENGNTRU_R_PROV_ENCAPSULATE_FAILED),
    "prov encapsulate failed"},
    {ERR_PACK(0, 0, ENGNTRU_R_PROV_KEYGEN_FAILED), "prov keygen failed"},
    {ERR_PACK(0, 0, ENGNTRU_R_WRONG_LENGTH), "wrong length"},
    {0, NULL}
};

static ERR_STRING_DATA ENGNTRU_lib_name[] = {
    {0, "engNTRU engine"},
    {0, NULL}
};

#endif

static int lib_code = 0;
static int error_loaded = 0;

int ERR_load_ENGNTRU_strings(void)
{
    if (lib_code == 0)
        lib_code = ERR_get_next_error_library();

    if (!error_loaded) {
#ifndef OPENSSL_NO_ERR
        ERR_load_strings(lib_code, ENGNTRU_str_functs);
        ERR_load_strings(lib_code, ENGNTRU_str_reasons);
        ENGNTRU_lib_name->error = ERR_PACK(lib_code, 0, 0);
        ERR_load_strings(0, ENGNTRU_lib_name);
#endif
        error_loaded = 1;
    }
    return 1;
}

void ERR_unload_ENGNTRU_strings(void)
{
    if (error_loaded) {
#ifndef OPENSSL_NO_ERR
        ERR_unload_strings(lib_code, ENGNTRU_str_functs);
        ERR_unload_strings(lib_code, ENGNTRU_str_reasons);
        ERR_unload_strings(0, ENGNTRU_lib_name);
#endif
        error_loaded = 0;
    }
}

void ERR_ENGNTRU_error(int function, int reason, char *file, int line)
{
    (void)(function); /* might be unused depending on ERR_PUT_error version */

    if (lib_code == 0)
        lib_code = ERR_get_next_error_library();
    ERR_PUT_error(lib_code, function, reason, file, line);
}
