/*
 * Generated by util/mkerr.pl DO NOT EDIT
 *
 *  engNTRU - An engine for batch NTRU PQC in OpenSSL.
 *  Copyright (C) 2019 Tampere University Foundation sr
 *
 *  This file is part of engNTRU.
 *
 *  engNTRU is free software: you can redistribute it and/or modify it under
 *  the terms of the GNU Lesser General Public License as published by the
 *  Free Software Foundation, either version 3 of the License, or (at your
 *  option) any later version.
 *
 *  engNTRU is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef HEADER_ENGNTRUERR_H
# define HEADER_ENGNTRUERR_H

# define ENGNTRUerr(f, r) ERR_ENGNTRU_error((f), (r), __FILE__, __LINE__)


# ifdef  __cplusplus
extern "C" {
# endif
int ERR_load_ENGNTRU_strings(void);
void ERR_unload_ENGNTRU_strings(void);
void ERR_ENGNTRU_error(int function, int reason, char *file, int line);
# ifdef  __cplusplus
}
# endif

/*
 * ENGNTRU function codes.
 */
# define ENGNTRU_F_ASN1_GENERIC_CTRL                      100
# define ENGNTRU_F_ASN1_GENERIC_PRIV_DECODE               101
# define ENGNTRU_F_ASN1_GENERIC_PRIV_ENCODE               102
# define ENGNTRU_F_ASN1_GENERIC_PUB_DECODE                103
# define ENGNTRU_F_ASN1_GENERIC_PUB_ENCODE                104
# define ENGNTRU_F_ENGNTRU_KEM_KEYPAIR_NEW                105
# define ENGNTRU_F_GENERIC_KEM_DECRYPT                    106
# define ENGNTRU_F_GENERIC_KEM_DERIVE                     107
# define ENGNTRU_F_GENERIC_KEM_ENCRYPT                    108
# define ENGNTRU_F_GENERIC_KEM_KEYGEN                     109

/*
 * ENGNTRU reason codes.
 */
# define ENGNTRU_R_INVALID_DERIVE                         100
# define ENGNTRU_R_INVALID_ENCODING                       101
# define ENGNTRU_R_INVALID_KEY                            102
# define ENGNTRU_R_INVALID_PEER_KEY                       103
# define ENGNTRU_R_INVALID_PRIVATE_KEY                    104
# define ENGNTRU_R_KEYS_NOT_SET                           105
# define ENGNTRU_R_MISSING_NID_DATA                       106
# define ENGNTRU_R_PROV_DECAPSULATE_FAILED                107
# define ENGNTRU_R_PROV_ENCAPSULATE_FAILED                108
# define ENGNTRU_R_PROV_KEYGEN_FAILED                     109
# define ENGNTRU_R_WRONG_LENGTH                           110

#endif
